/*-
 * Copyright (c) 2000 Mitsuru IWASAKI <iwasaki@freebsd.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$FreeBSD$
 */

#include <sys/param.h>

#include <stdarg.h>
#include <stdio.h>

#include <acpi.h>

void	__cli()
{
}

void	__sti()
{
}

ACPI_STATUS
AcpiOsShutdown (void)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsBreakpoint(NATIVE_CHAR *Message)
{
    return(AE_OK);
}

UINT32
AcpiOsGetLine(NATIVE_CHAR *Buffer)
{
	fgets(Buffer, 80, stdin);
	Buffer[strlen(Buffer) - 1] = 0;
}

void
AcpiOsDbgAssert(void *FailedAssertion, void *FileName, UINT32 LineNumber, NATIVE_CHAR *Message)
{
    printf("ACPI: %s:%d - %s\n", (char *)FileName, LineNumber, Message);
    printf("ACPI: assertion  %s\n", (char *)FailedAssertion);
}

ACPI_STATUS
AcpiOsInitialize(void)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsTerminate(void)
{
    return(AE_OK);
}

UINT8
AcpiOsIn8(ACPI_IO_ADDRESS InPort)
{
	return(0);
}

UINT16
AcpiOsIn16(ACPI_IO_ADDRESS InPort)
{
	return(0);
}

UINT32
AcpiOsIn32(ACPI_IO_ADDRESS InPort)
{
	return(0);
}

void
AcpiOsOut8(ACPI_IO_ADDRESS OutPort, UINT8 Value)
{
}

void
AcpiOsOut16(ACPI_IO_ADDRESS OutPort, UINT16 Value)
{
}

void
AcpiOsOut32(ACPI_IO_ADDRESS OutPort, UINT32 Value)
{
}

#if ACPICA_VERSION >= 20001115
UINT8
AcpiOsMemIn8(ACPI_PHYSICAL_ADDRESS InAddr)
{
	return(0);
}
  
UINT16
AcpiOsMemIn16(ACPI_PHYSICAL_ADDRESS InAddr)
{
	return(0);
}
 
UINT32
AcpiOsMemIn32(ACPI_PHYSICAL_ADDRESS InAddr)
{
	return(0);
}
 
void
AcpiOsMemOut8(ACPI_PHYSICAL_ADDRESS OutAddr, UINT8 Value)
{
}

void
AcpiOsMemOut16(ACPI_PHYSICAL_ADDRESS OutAddr, UINT16 Value)
{
}

void
AcpiOsMemOut32(ACPI_PHYSICAL_ADDRESS OutAddr, UINT32 Value)
{
}
#endif

ACPI_STATUS
AcpiOsReadPciCfgByte (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT8 *Value)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsReadPciCfgWord (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT16 *Value)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsReadPciCfgDword (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT32 *Value)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsWritePciCfgByte (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT8 Value)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsWritePciCfgWord (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT16 Value)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsWritePciCfgDword (UINT32 Bus, UINT32 DeviceFunction, UINT32 Register, UINT32 Value)
{
    return(AE_OK);
}
ACPI_STATUS
AcpiOsInstallInterruptHandler(UINT32 InterruptNumber, OSD_HANDLER ServiceRoutine, void *Context)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsRemoveInterruptHandler (UINT32 InterruptNumber, OSD_HANDLER ServiceRoutine)
{
    return(AE_OK);
}

void *
AcpiOsAllocate(UINT32 Size)
{
	return(malloc((size_t)Size));
}

void *
AcpiOsCallocate (UINT32 Size)
{
	void        *alloc;   
 
	alloc = malloc((size_t)Size);
	if (alloc != NULL)
		bzero(alloc, (size_t)Size);
	return(alloc);
}

void
AcpiOsFree (void *Memory)
{
	free(Memory);
}

ACPI_STATUS
AcpiOsMapMemory (ACPI_PHYSICAL_ADDRESS PhysicalAddress, UINT32 Length, void **LogicalAddress)
{
    return(AE_OK);
}

void
AcpiOsUnmapMemory (void *LogicalAddress, UINT32 Length)
{
}

BOOLEAN
AcpiOsReadable (void *Pointer, UINT32 Length)
{
    return(TRUE);
}

BOOLEAN
AcpiOsWritable (void *Pointer, UINT32 Length)
{
    return(TRUE);
}

ACPI_STATUS
AcpiOsQueueForExecution(UINT32 Priority, OSD_EXECUTION_CALLBACK Function, void *Context)
{
    return(AE_OK);
}

static void
AcpiOsExecuteQueue(void *arg, int pending)
{
}

void
AcpiOsSleep (UINT32 Seconds, UINT32 Milliseconds)
{
}

void
AcpiOsSleepUsec (UINT32 Microseconds)
{
}

AcpiOsPrintf (const NATIVE_CHAR *Format, ...)
{
    int		retval;
    va_list	ap;

    va_start(ap, Format);
    retval = AcpiOsVprintf(Format, ap);
    va_end(ap);
    return(retval);
}

INT32
AcpiOsVprintf (const NATIVE_CHAR *Format, va_list Args)
{
    return(vprintf(Format, Args));
}

ACPI_STATUS
AcpiOsCreateSemaphore(UINT32 MaxUnits, UINT32 InitialUnits, ACPI_HANDLE *OutHandle)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsDeleteSemaphore (ACPI_HANDLE Handle)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsWaitSemaphore(ACPI_HANDLE Handle, UINT32 Units, UINT32 Timeout)
{
    return(AE_OK);
}

ACPI_STATUS
AcpiOsSignalSemaphore(ACPI_HANDLE Handle, UINT32 Units)
{
    return(AE_OK);
}
